//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: BoxPosition
// Version: 1.0
// Last Modified: 14/02/2003
//----------------------------------------------------------------

/**
* This class creates a BoxPosition Object which holds the 
* horizontal and vertical positions in terms of the grid of a Box
* Object.
*/
public class BoxPosition{
	int horiz,vert;
	
	/**
	* Constructs a new BoxPosition object when passed parameters
	* representing the horizontal and vertical positions of the 
	* BoxPositions in trems of the Grid.
	*/ 
	public BoxPosition(int horizPar, int vertPar){
		horiz = horizPar;
		vert = vertPar;
	}

	/**
	* Returns the horizontal position of the BoxPosition in terms of 
	* the Grid.
	* @returns the horizontal position of the BoxPosition in terms of 
	* the Grid.
	*/
	public int getHoriz(){
		return horiz;
	}

	/**
	* Returns the vertical position of the BoxPosition in terms of 
	* the Grid.
	* @returns the vertical position of the BoxPosition in terms of 
	* the Grid.
	*/
	public int getVert(){
		return vert;
	}

	/**
	* Returns a boolean dependent on whether the passed BoxPosition
	* Object shares the same horizontal and vertical int values as
	* this Object.
	* @param bpPar the BoxPosition Object to be tested to see if it
	* shares the same horizontal and vertical ints as this Object.
	* @returns  boolean dependent on whether the passed BoxPosition
	* Object shares the same horizontal and vertical int values as
	* this Object.
	*/
	public boolean equals(BoxPosition bpPar){
		if (bpPar.getHoriz()==horiz && bpPar.getVert()==vert)
			return true;
		return false;
	}

	/**
	* Returns a boolean dependent on whether the ints passed shares 
	* the same horizontal and vertical int values as this Object.
	* @param horizPar an int representing the horizontal position to
	* be tested to see if it is the same as this Object's horizontal
	* value.
	* @param vertPar an int representing the vertical position to
	* be tested to see if it is the same as this Object's vertical
	* value.
	* @returns  boolean dependent on whether the passed parameters
	* share the same horizontal and vertical int values as this 
	* Object.
	*/
	public boolean equals(int horizPar, int vertPar){
		if (horizPar==horiz && vertPar==vert)
			return true;
		return false;
	}
}