//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: CustomPanel
// Version: 1.1
// Last Modified: 14/02/2004
// Version 1.1: Changed paint so that it looks at Player vector
// lists of occupied sqaures to determine colour to paint squares.
// NOTE: Modified code from CustomPanel.java of Deitel & Deitel's
// "Java, How to program." 
//----------------------------------------------------------------

// Java core packages
import java.awt.*;

// Java extension packages
import javax.swing.*;
import java.io.*;

/**
* This Class creates the main panel of the game which displays the
* grid and the positions of all the men of both sides.  This class
* also allows interaction to move the men around the grid 
* appropriatly.
*/
public class CustomPanel extends JPanel {
	RiskGame theGame;
	private String title;
	private boolean retreatAllowed;
	
	/**
	* Constructs a new CustomPanel Object.
	*/
   	public CustomPanel(){
		theGame=null;
		retreatAllowed=false;
	}
	
	/**
	* Paints what is to be displayed by the CustomPanel
	* @param g a Graphics object which paints CustomPanel
	*/
	public void paint( Graphics g ){
		if (CustomPanelTest.getRefreshView()){
		if (theGame!=null){
   			int curPS[];
      		super.paintComponent( g );
	  		g.setColor(Color.black);
			g.setFont(new Font("Arial",1,10));
			for (int i=0; i<theGame.getGridX(); i++){
				for (int j=0; j<theGame.getGridY(); j++){
					curPS = theGame.getGrid().getBox(i,j).getPosSize(); 
					if (theGame.getRedPlayer().findSquare(new BoxPosition(i,j)) && (!theGame.getBluePlayer().findSquare(new BoxPosition(i,j)))){
				//	if (theGame.getGrid().getBox(i,j).getCol()==Box.RED){ 
						g.setColor(Color.RED);
						g.fillRect(curPS[0],curPS[1],curPS[2],curPS[3]);
						g.setColor(Color.BLACK);
						g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getRedNum()), curPS[0]+4, curPS[1]+12);
					}
					if ((!theGame.getRedPlayer().findSquare(new BoxPosition(i,j))) && theGame.getBluePlayer().findSquare(new BoxPosition(i,j))){
				//	if (theGame.getGrid().getBox(i,j).getCol()==Box.BLUE){ 
						g.setColor(Color.BLUE);
						g.fillRect(curPS[0],curPS[1],curPS[2],curPS[3]);
						g.setColor(Color.BLACK);
						if (theGame.getGrid().getBox(i,j).getBlueNum()>999)
							g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-24, curPS[1]+curPS[3]-2);
						else if (theGame.getGrid().getBox(i,j).getBlueNum()>99)
							g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-19, curPS[1]+curPS[3]-2);
						else if (theGame.getGrid().getBox(i,j).getBlueNum()>9)
							g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-14, curPS[1]+curPS[3]-2);
						else g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-9, curPS[1]+curPS[3]-2);
					}	
					if (theGame.getRedPlayer().findSquare(new BoxPosition(i,j)) && theGame.getBluePlayer().findSquare(new BoxPosition(i,j))){
				//	if (theGame.getGrid().getBox(i,j).getCol()==Box.BOTH){
						g.setColor(Color.RED);
						int xCoords[] = new int[3];
						int yCoords[] = new int[3];
						xCoords[0]=curPS[0];
						yCoords[0]=curPS[1];
						xCoords[1]=curPS[0]+curPS[2];
						yCoords[1]=curPS[1];
						xCoords[2]=curPS[0];
						yCoords[2]=curPS[1]+curPS[3]; 
						g.fillPolygon(xCoords, yCoords, 3);
						g.setColor(Color.BLACK);
						g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getRedNum()), curPS[0]+4, curPS[1]+12);
						g.setColor(Color.BLUE);
						xCoords[0]=curPS[0]+curPS[2];
						yCoords[0]=curPS[1];
						xCoords[1]=curPS[0]+curPS[2];
						yCoords[1]=curPS[1]+curPS[3];
						xCoords[2]=curPS[0];
						yCoords[2]=curPS[1]+curPS[3]; 
						g.fillPolygon(xCoords, yCoords, 3);
						g.setColor(Color.BLACK);
						if (theGame.getGrid().getBox(i,j).getBlueNum()>999)
							g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-24, curPS[1]+curPS[3]-2);
						else if (theGame.getGrid().getBox(i,j).getBlueNum()>99)
							g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-19, curPS[1]+curPS[3]-2);
						else if (theGame.getGrid().getBox(i,j).getBlueNum()>9)
							g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-14, curPS[1]+curPS[3]-2);
						else g.drawString(Long.toString(theGame.getGrid().getBox(i,j).getBlueNum()), curPS[0]+curPS[2]-9, curPS[1]+curPS[3]-2);
					}	
					g.setColor(Color.BLACK);
					g.drawRect(curPS[0],curPS[1],curPS[2],curPS[3]);		
					if (theGame.getCurBox()!=null){
						int curBoxH = theGame.getCurBox().getHoriz();
						int curBoxV = theGame.getCurBox().getVert();
						if (i==curBoxH && j==curBoxV){
							g.drawRect(curPS[0]+1,curPS[1]+1,curPS[2]-2,curPS[3]-2);
						}	
					}	
					g.setColor(Color.YELLOW);
					if (theGame.getFromBox()!=null){
						int fromBoxH = theGame.getFromBox().getHoriz();
						int fromBoxV = theGame.getFromBox().getVert();
						if (i==fromBoxH && j==fromBoxV){
							g.drawRect(curPS[0]+1,curPS[1]+1,curPS[2]-2,curPS[3]-2);
						}	
					}	
					g.setColor(Color.WHITE);
					if (theGame.getToBox()!=null){
						int toBoxH = theGame.getToBox().getHoriz();
						int toBoxV = theGame.getToBox().getVert();
						if (i==toBoxH && j==toBoxV){
							g.drawRect(curPS[0]+1,curPS[1]+1,curPS[2]-2,curPS[3]-2);
						}	
					}	
				}
			}
		}
		}
   	}

	/**
	* Returns a boolean dependent on whether the last request 
	* for a retreat is valid.
	* @returns a boolean dependent on whether the last request 
	* for a retreat is valid.
	*/
	public boolean getRetreatAllowed(){
		if (retreatAllowed){
			retreatAllowed=false;
			return true;
		}
		return false;
	}

	/**
	* Returns the BoxPosition which represents the Box that the 
	* co-ordinate parameters passed lie within, otherwise returns 
	* null.
	* @param x an int representing the horizontal co-ordinate of 
	* the point that the BoxPosition to be return should encompass.
	* @param y an int representing the vertical co-ordinate of the 
	* point that the BoxPosition to be return should encompass.  
	* @returns the BoxPosition which represents the Box that the 
	* co-ordinate parameters passed lie within, otherwise returns 
	* null. 
	*/
	public BoxPosition theClickedBox(int x, int y){
		int insetX = theGame.getGrid().getInsetX();
		int insetY = theGame.getGrid().getInsetY();
		int gridArea =  theGame.getGrid().getGridArea();
		if (x<insetX || x>insetX+gridArea || y<insetY || y>insetY+gridArea){
			return null;
		}
		float boxWidth = gridArea/theGame.getGridX();
		float boxWidthHalf = gridArea/(theGame.getGridX()*2);
		float boxHeight = gridArea/theGame.getGridY();
		float boxHeightHalf = gridArea/(theGame.getGridY()*2);
		int boxHorizNum = Math.round((x-boxWidthHalf-insetX)/boxWidth);
		int boxVertNum = Math.round((y-boxHeightHalf-insetY)/boxHeight);
		return new BoxPosition(boxHorizNum, boxVertNum);

	}
	
	/**
	* Returns a boolean dependent on whether the current 
	* retreat was possible to perform.
	* @returns a boolean dependent on whether the current 
	* retreat was possible to perform.
	*/
	public boolean retreatMen(){
		BoxPosition curBox = theGame.getCurBox();
		BoxPosition bBox = theGame.getBattleBox();
		if ((theGame.getDefWDing() && theGame.getTurn()==Box.RED)||(theGame.getAttWDing()&& theGame.getTurn()==Box.BLUE)){					
			theGame.getGrid().getBox(curBox).setBlueNum(theGame.getGrid().getBox(bBox).getBlueNum()+theGame.getGrid().getBox(curBox).getBlueNum());
			if (!theGame.getPlayer(Box.BLUE).findSquare(curBox)) theGame.getBluePlayer().addSquare(theGame.getGrid().getBox(curBox));
			theGame.getGrid().getBox(bBox).setBlueNum(0);
			theGame.getBluePlayer().removeSquare(bBox);
			if (theGame.getDefWDing()) theGame.setDefWDing(false);
			else if (theGame.getAttWDing()) theGame.setAttWDing(false);
			return true;
		}
		else if ((theGame.getDefWDing() && theGame.getTurn()==Box.BLUE)||(theGame.getAttWDing()&& theGame.getTurn()==Box.RED)){	
			theGame.getGrid().getBox(curBox).setRedNum(theGame.getGrid().getBox(bBox).getRedNum()+theGame.getGrid().getBox(curBox).getRedNum());
			if (!theGame.getPlayer(Box.RED).findSquare(curBox))theGame.getRedPlayer().addSquare(theGame.getGrid().getBox(curBox));
			theGame.getGrid().getBox(bBox).setRedNum(0);
			theGame.getRedPlayer().removeSquare(bBox);
			if (theGame.getDefWDing()) theGame.setDefWDing(false);
			else if (theGame.getAttWDing()) theGame.setAttWDing(false);
			return true;
		}
		return false;
		
	}	
	
	/**
	* Returns a boolean dependent on whether the passed
	* BoxPosition parameter represents a Box is occupied
	* by opposition men.
	* @param curBP the BoxPosition to be tested to see if
	* the represented Box is occupied by opposition men.
	* @returns a boolean dependent on whether the passed
	* BoxPosition parameter represents a Box is occupied
	* by opposition men.
	*/
	private boolean notOppositionBox(BoxPosition curBP){
		Box curBox = theGame.getGrid().getBox(curBP);
		if (curBox.getCol()==Box.BLUE){
			if (theGame.getTurn()==Box.RED  && theGame.getAttWDing()) return false;
			if (theGame.getTurn()==Box.BLUE  && theGame.getDefWDing()) return false;
		}
		else if (curBox.getCol()==Box.RED){
			if (theGame.getTurn()==Box.RED  && theGame.getDefWDing()) return false;
			if (theGame.getTurn()==Box.BLUE  && theGame.getAttWDing()) return false;
		}
		return true;
	}

	/**
	* Determines how the gamestate / UI should alter 
	* dependent on where the CustomPanel has been clicked.
	* @param x an int representing the horizontal co-ordinate 
	* of the clicked point.
	* @param y an int representing the vertical co-ordinate 
	* of the clicked point.
	*/
	public void handleClick(int x, int y){
		if (theGame.getDefWDing()||theGame.getAttWDing()){
			BoxPosition curBox = theClickedBox(x,y);
			if (curBox!=null){
				BoxPosition bBox = theGame.getBattleBox();
				if (curBox.equals(bBox.getHoriz()-1, bBox.getVert())||curBox.equals(bBox.getHoriz()+1, bBox.getVert())||curBox.equals(bBox.getHoriz(), bBox.getVert()-1)||curBox.equals(bBox.getHoriz(), bBox.getVert()+1)){
					if (notOppositionBox(curBox)){
						theGame.setCurBox(curBox);
						if (retreatMen()){
							retreatAllowed=true;
							theGame.setDefWDing(false);
							theGame.setAttWDing(false);				
						}			
					}
				}
				if (theGame.getDiagonalSquaresAdjacent()){
					if (curBox.equals(bBox.getHoriz()-1, bBox.getVert()-1)||curBox.equals(bBox.getHoriz()+1, bBox.getVert()+1)||curBox.equals(bBox.getHoriz()+1, bBox.getVert()-1)||curBox.equals(bBox.getHoriz()-1, bBox.getVert()+1)){
						if (notOppositionBox(curBox)){
							theGame.setCurBox(curBox);
							if (retreatMen()){
								retreatAllowed=true; 
								theGame.setDefWDing(false);
							    theGame.setAttWDing(false);	
							}
						}
					}
				}
			}
		}
		else if (theGame.getGameState()==RiskGame.IN_GAME){
		//	System.out.println("We are in the game!");
			BoxPosition curBox = theGame.getCurBox();
			if (theGame.getCurBox()==null){
		//		System.out.println("There is no current box!");
				theGame.setCurBox(theClickedBox(x,y));
			}
			else if (theGame.getGrid().getBox(curBox).getCol()!=theGame.getTurn()&& theGame.getFromBox()==null){
		//		System.out.println("There is current box but is the wrong colour!");
				theGame.setCurBox(theClickedBox(x,y));
			}
			else if (theGame.getGrid().getBox(curBox).getCol()==theGame.getTurn()){
		//		System.out.println("There is current box and is the right colour!");
				theGame.setFromBox(curBox);
				BoxPosition nextBox = theClickedBox(x,y);
				if (nextBox!=null){
					int curBPH = curBox.getHoriz();
					int curBPV = curBox.getVert();	
					if (nextBox.equals(curBPH-1, curBPV)||nextBox.equals(curBPH+1, curBPV)||nextBox.equals(curBPH, curBPV-1)||nextBox.equals(curBPH, curBPV+1)){
						theGame.setCurBox(nextBox);
						theGame.setToBox(nextBox);	
					}
					if (theGame.getDiagonalSquaresAdjacent()){
						if (nextBox.equals(curBPH-1, curBPV-1)||nextBox.equals(curBPH+1, curBPV+1)||nextBox.equals(curBPH+1, curBPV-1)||nextBox.equals(curBPH-1, curBPV+1)){
							theGame.setCurBox(nextBox);
							theGame.setToBox(nextBox);	
						}
					}
				}
			}	
		}
	}
	
	/**
	* Attempts to perform the withdrawal specified by the 
	* parsed parameter, if it is valid.
	* @param retreatMove a RiskGameMove specifying the 
	* withdrawal that should be performed.
	*/
	public void doWithdraw(RiskGameMove retreatMove){
		if (retreatMove!=null){
			theGame.setCurBox(retreatMove.getToBox());	
			if (retreatMen())retreatAllowed=true;
		}
		else{ 
			retreatAllowed = false;
			if (theGame.getDefWDing()) theGame.setDefWDing(false);
			else if (theGame.getAttWDing()) theGame.setAttWDing(false);
		}
	}
		
	/*public void setTitle(String titlePar){
		title = titlePar;
	}*/

	/**
	* Returns the RiskGame Object which the CustomPanel 
	* represents.
	* @returns the RiskGame Object which the CustomPanel 
	* represents.
	*/
	public RiskGame getGame(){
		return theGame;
	}
	
	/**
	* Sets the RiskGame Object that the CustomPanel should
	* represent.
	* @param theGamePar the RiskGame Object the CustomPanel 
	* should be set to represent.
	*/
	public void setGame(RiskGame theGamePar){
		theGame=theGamePar;
	}
}  



