import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;
// This code was developed from the tutorial code for file filters available at:
// www.java.sun.com/doc/books/tutorial/uiswing/components/example-1dot4/ImageFilter.java
/** 
 * This class creates filter to sort out all the Game Positions files from other 
 * files.
 * @see javax.swing.filechooser.FileFilter
 */
public class RiskGamePositionsFileFilter extends FileFilter {

    /**
	* Returns a <code>boolean</code>, true if a '.pos' file or a folder, 
	* otherwise returns false.
	* @param f a <code>File</code> to be check to see if it is a '.pos' file 
	* or a folder.
	* @return a <code>boolean</code>, true if a '.pos' file or a folder, 
	* otherwise returns false.
	*/
	public boolean accept(File f) {
  		if (f.isDirectory())
           	return true;
		String extension = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');
		if (i > 0 &&  i < s.length() - 1) {
            extension = s.substring(i+1).toLowerCase();
        }
		if (extension != null) {
            if (extension.equals("pos"))
					return true;
				else
               return false;
        }
        return false;
    }

    /**
	* Returns a <code>String</code> description of the 
	* <code>FileFilter</code> for the <code>FileChooser</code> window.
	* @return a <code>String</code> description of the 
	* <code>FileFilter</code> for the <code>FileChooser</code> window.
	*/
    public String getDescription() {
        return "Risk Game Positions File (*.pos)";
    }
}